# This file was auto-generated by Fern from our API Definition.

from ..core.unchecked_base_model import UncheckedBaseModel
import pydantic
import typing
from .trace_status import TraceStatus
from ..core.pydantic_utilities import IS_PYDANTIC_V2


class CreateFlowLogResponse(UncheckedBaseModel):
    """
    Response for a Flow Log.
    """

    id: str = pydantic.Field()
    """
    Unique identifier for the Log.
    """

    flow_id: str = pydantic.Field()
    """
    Unique identifier for the Flow.
    """

    version_id: str = pydantic.Field()
    """
    Unique identifier for the Flow Version.
    """

    trace_status: typing.Optional[TraceStatus] = pydantic.Field(default=None)
    """
    Status of the Trace. When a Trace is marked as `complete`, no more Logs can be added to it. Monitoring Evaluators will only run on `complete` Traces.
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
