# This file was auto-generated by Fern from our API Definition.

from ..core.unchecked_base_model import UncheckedBaseModel
import pydantic
import typing
from .version_stats_response_evaluator_version_stats_item import VersionStatsResponseEvaluatorVersionStatsItem
from ..core.pydantic_utilities import IS_PYDANTIC_V2


class VersionStatsResponse(UncheckedBaseModel):
    version_id: str = pydantic.Field()
    """
    Unique identifier for the evaluated Version.
    """

    batch_id: typing.Optional[str] = pydantic.Field(default=None)
    """
    Unique identifier for the batch of Logs to include in the Evaluation.
    """

    num_logs: int = pydantic.Field()
    """
    The total number of existing Logs in this Run.
    """

    evaluator_version_stats: typing.List[VersionStatsResponseEvaluatorVersionStatsItem] = pydantic.Field()
    """
    Stats for each Evaluator Version applied to this Run.
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
